#include "GroupData.h"


GroupListe g_liste;


Group::Group(char *line)
{	char *p;

	if((p=strchr(line, ':'))==0) return;
	
	*p=0;
	g_name=line; line=++p;
	
	p=strchr(line, ':'); *p=0;
	g_passwd=line; line=++p;
	
	p=strchr(line, ':'); *p=0;
	g_gid=0xFFFF&atoi(line); line=++p;
	
	members.setAutoDelete(TRUE);
	admins.setAutoDelete(TRUE);
	while((p=strchr(line, ',')))
	{	*p=0;
		members.append(line);
		line=++p;
	}
	p=strchr(line, '\n');
	*p=0;
	if(p>line) members.append(line);
}

GroupListe::GroupListe()
{	setAutoDelete(TRUE);
}

GroupListe::~GroupListe()
{
}

Group * GroupListe::getgroup(QString str)
{	for(int i=0; i<(int)count(); i++)
	{	if(name(i)==str) return at(i);
	}
	
	return NULL;
}

int GroupListe::read()
{	QFile file(GROUP_FILE);
    char line[200];
    	
    if(file.open(IO_ReadOnly) == 0) return -1;	// Fehler
	else
	{	while(file.readLine(line, 198) > 0)
		{	if(*line!='+') append(new Group(line));
			if(gid(at())==min_gid) gid100=at();
		}
		file.close();
		gsdw_read();
	}
	
	sort();
	return 0;
}

int GroupListe::write()
{	int zidx;

	rename(GROUP_FILE".oo", GROUP_FILE".ooo");
	rename(GROUP_FILE".o", GROUP_FILE".oo");
	rename(GROUP_FILE, GROUP_FILE".o");
	QFile file(GROUP_FILE);
	QTextStream cout(&file);

	if(file.open(IO_WriteOnly) == 0) return -1;	// Fehler
	else
	{	zidx=at();
		for(int i=0; i<(int)count(); i++)
		{	int n;
			Group *group;
			
			group=at(i);
			cout << group->g_name << ':';
			cout << "*:";
			cout << group->g_gid << ':';
			
			n=(int)group->members.count();
			for(int j=0; j<n; j++)
			{	cout << group->members.at(j);
				if(j<n-1) cout << ',';
			}
			cout << '\n';
		}
		file.close();
		gsdw_write();
		at(zidx);
	}
	
	chmod(GROUP_FILE, GROUP_FILE_MASK);
	return 0;
}

void GroupListe::gsdw_read()
{	QFile file(GSHADOW_FILE);
    char line[200];
    Group *grp;
    	
    if(file.open(IO_ReadOnly) == 0)
	{	QMessageBox::warning(0, 0, "Error opening /etc/gshadow for reading.");
		return;
  	}

	while(file.readLine(line, 198) > 0)
	{	char *p, *p1, *p2, *p3, *p4;

		p1=line;
		if(*p1=='+') break;
		if((p2=strchr(p1, ':'))==0) break;
		*p2=0;
		if((p3=strchr(++p2, ':'))==0) break;
		*p3=0;
		if((p4=strchr(++p3, ':'))==0) break;
		*p4=0; p=++p4;
		while(*p) ++p;
		if(p[-1]=='\n') p[-1]=',';
		else {p[0]=','; p[1]=0;}
		
		if((grp=getgroup(p1)))
		{	grp->g_passwd=p2;
			while((p=strchr(p3, ',')))
			{	*p=0;
				grp->admins.append(p3);
				p3=++p;
			}
			grp->admins.append(p3);
			
			while((p=strchr(p4, ',')))
			{	char f=1;

				*p=0;
				for(uint i=0; i<grp->members.count(); ++i)
				    if(strcmp(p4, grp->members.at(i))==0) {f=0; break;}
				
				if(f) grp->members.append(p4);
				p4=++p;
			}
		}
	    else
	    {	char s[100];
	        
        	sprintf(s, "No /etc/group entry for %s. Entry will be removed at the next `Save'-operation.", p1);
		    QMessageBox::warning(0, 0, s);
        }
	}
	
	file.close();
}


void GroupListe::gsdw_write()
{	int zidx;
	
	rename(GSHADOW_FILE".oo", GSHADOW_FILE".ooo");
	rename(GSHADOW_FILE".o", GSHADOW_FILE".oo");
	rename(GSHADOW_FILE, GSHADOW_FILE".o");
	QFile file(GSHADOW_FILE);
	QTextStream cout(&file);
	
	if(file.open(IO_WriteOnly) == 0)
	{	QMessageBox::warning(0, 0, "Error opening /etc/gshadow for writing.");
		return;
  	}

	zidx=at();
	for(int i=0; i<(int)count(); i++)
	{	int n;
		Group *group;
		
		group=at(i);
		cout << group->g_name << ':';
		cout << group->g_passwd << ':';

		n=(int)group->admins.count();
		for(int j=0; j<n; j++)
		{	cout << group->admins.at(j);
			if(j<n-1) cout << ',';
		}
		cout << ':';

		n=(int)group->members.count();
		for(int j=0; j<n; j++)
		{	cout << group->members.at(j);
			if(j<n-1) cout << ',';
		}
		cout << '\n';
	}
	file.close();
	at(zidx);
	chmod(GSHADOW_FILE, GSHADOW_FILE_MASK);
}

void  GroupListe::sort()
{	int flg, i, idx, n;
	Group *grp;
	
	idx=at();
	n=count()-1;
	do					
	{	flg=1;				
		for(i=0; i<n; ++i)
		{	if(name(i) > (const char *)name(i+1))
			{	grp=take(i);
				insert(i+1, grp);
				if(i==idx) ++idx;
				else if(i==idx-1) --idx;
				flg=0;
			}
		}
	}
	while(flg==0);
	at(idx);
}

int GroupListe::getid(uint u_gid)
{	for(int i=0; i<(int)count(); i++)
	{	if(gid(i)==u_gid) return i;
	}
	
	return -1;
}

uint GroupListe::getfreegid()
{	uint id=min_gid;

	for(int i=0; i<(int)count(); ++i) if(gid(i)==id) {i=-1; ++id;}
	return id;
}

QString GroupListe::gidToName(uint u_gid)
{	int id=getid(u_gid);

	if(id==-1) return "none";
	else return at(id)->g_name;
}

void GroupListe::deluser(QString name)
{	uint i, idx;
	Group *grp;
	
	idx=at();
	for(i=0; i<count(); ++i)					
	{	grp=at(i);
		grp->members.remove(name);
		grp->admins.remove(name);
	}
	
	at(idx);
}

void GroupListe::renuser(QString oldname, QString newname)
{	uint i, idx;
	Group *grp;
	
	idx=at();
	for(i=0; i<count(); ++i)					
	{	grp=at(i);
		if(grp->members.remove(oldname)==TRUE) grp->members.append(newname);
		if(grp->admins.remove(oldname)==TRUE) grp->admins.append(newname);
	}
	
	at(idx);
}