#ifndef misc_included
#define misc_included

#include <qdir.h>
#include <qlist.h>
#include <kapp.h>
#include <kconfig.h>
#include <stdlib.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <time.h>
#include <unistd.h>
#include <mntent.h>

#define	KU_VERSION	"0.9.4"
#define	QUIDMIN	100
#define QUIDMAX	16000


extern QString quotadevice;
extern KApplication *ka;
extern KConfig *kc;

extern QString passwd;


// Default-Werte

// Home-Dir

extern QString def_home;
extern int createmode,
		   homes_mode;


// Directories

extern QString def_mail,
	           def_skel,
	           def_shell,
		   	   def_ypcmd;


// Misc:

extern int delhome,
	       delmail;
	   
extern QString def_createscript,
	           def_deletescript;



// Shadow:
	
extern int sortmode,
	   	   vw_group,
		   expire_mode,		// 0 -> Period
							// 1 -> Date
		   def_expire,
		   def_fixed,
		   def_change,
		   def_warn,
		   def_inact;

extern uint min_uid,
	        min_gid;

// Quota:

extern long int def_fsoft,
			   	def_fhard,
			   	def_fgrace,
			   	def_isoft,
			   	def_ihard,
			   	def_igrace;

extern int ischanged,		// 1 -> Database has changed
	       isquota,			// 1 -> Quota-Support
	       isyp;			// 1 -> YP-Support

extern QString vw_grpstr,
	       	   printername,
	           printcommand;
	       
extern time_t today;


void getdefaults();
void putdefaults();
int getquotadevice();
QString date(time_t);
time_t date(QString);
char *salt();
int i64c(int);
int renamedir(QString, QString);

#endif	// misc_included
